<?php
/*
Plugin Name: Pakkepost WooCommerce Shipping Method
Description: WooCommerce Pakkepost Shipping Method and live rates.
Version: 2.2.2
Author: Pakkepost Developer
Author URI: https://pakkepost.no/
Text Domain: shipping-pakkepost
Domain Path: /lang/
Requires at least: 4.5
WC requires at least: 3.8
Requires PHP: 5.6
*/
add_filter('https_local_ssl_verify', '__return_true');
if (!defined('ABSPATH')) {
    exit;
}

if (!defined('WPINC')) {
    die('security by preventing any direct access to your plugin file');
}
define("WF_BRING_ID", "Pakkepost");
add_action('add_meta_boxes', 'add_meta_boxesws');
function add_meta_boxesws()
{
    add_meta_box('custom_order_meta_box', __('Booking Shipment Section'), 'custom_metabox_content', 'shop_order', 'normal', 'default');
}
ob_start();
?>
    <style>
        .trackingTable th{
            padding:5px;
            background-color: lightgrey;
            border: 1px solid;
        }
        .trackingTable td {
            padding:5px;
            border: 1px solid;
        }
        .trackingTable tr {
            padding:5px;
            border: 1px solid;
        }
    </style>
    <script type="text/javascript">
        function bookShipment(el, event, orderId) {
            var form = document.createElement("form");
            var orders = [];
            if ((typeof orderId === 'undefined') || (!orderId)) {
                jQuery('#the-list input[name="post[]"]').each(function () {
                    if (this.checked) {
                        orders.push(this.value);
                    }
                });
            } else {
                orders.push(orderId);
            }
            for (var i = 0; i < orders.length; i++) {

                var currentOrderId = orders[i];
                var shipType = document.createElement("input");
                shipType.type = 'hidden';
                shipType.name = 'shipping_type[' + currentOrderId + ']';
                var stEl = document.getElementsByName('shipping_type[' + currentOrderId + ']');
                if ((stEl) && (stEl.length >= 1)) {
                    shipType.value = jQuery(stEl[0]).val();
                    if (shipType.value == 0) {
                        return false;
                    }
                    form.appendChild(shipType);
                }
                var homeDelivery = document.createElement("input");
                homeDelivery.type = 'hidden';
                homeDelivery.name = 'home_delivery[' + currentOrderId + ']';
                var hdEl = document.getElementsByName('home_delivery[' + currentOrderId + ']');
                if ((hdEl) && (hdEl.length >= 1)) {
                    if (hdEl[0].checked) {
                        homeDelivery.value = 'hjemlevering';
                    } else {
                        homeDelivery.value = '';
                    }
                    form.appendChild(homeDelivery);
                }

/*                var oversize = document.createElement("input");
                oversize.type = 'hidden';
                oversize.name = 'oversize-INDEX[' + currentOrderId + ']';
                var hdEl = document.getElementsByName('oversize-INDEX[' + currentOrderId + ']');
                if ((hdEl) && (hdEl.length >= 1)) {
                    if (hdEl[0].checked) {
                        oversize.value = 'oversize';
                    } else {
                        oversize.value = '';
                    }
                    form.appendChild(oversize);
                }*/

                let numberOfPackagesElement = document.createElement("input");
                numberOfPackagesElement.type = 'hidden';
                numberOfPackagesElement.name = 'number_of_packages';
                let numberOfPackages = document.getElementsByName('number_of_packages');
                numberOfPackagesElement.value = jQuery(numberOfPackages[0]).val();
                form.appendChild(numberOfPackagesElement);

                var orderIdEl = document.createElement("input");
                orderIdEl.type = 'hidden';
                orderIdEl.name = 'order_id[' + currentOrderId + ']';
                orderIdEl.value = currentOrderId;
                form.appendChild(orderIdEl);
            }
            if (orders.length === 0) {
                return false;
            }
            var actionEl = document.createElement("input");
            actionEl.type = 'hidden';
            actionEl.name = 'action';
            actionEl.value = 'my_action_pakkepost';
            form.appendChild(actionEl);
            form.name = 'pakkepostform';
            form.method = "POST";
            form.action = el.href;
            document.body.appendChild(form);
            console.log(jQuery(form).serialize());
            form.submit();

/* TODO - add this later

          // Serialize the form data
          var formData = jQuery(form).serialize();

          // Create an AJAX request
          jQuery.ajax({
            type: "POST",           // Use POST method
            url: el.href,            // Set the URL to the form's action URL
            data: formData,          // Send the serialized form data
            crossDomain: true,
            success: function(response) {
              console.log(response); // Handle the response from the server here
              if (response === '0') {
                alert('There has been an error. Please try again.');
              } else {
                alert(response)
              }
            }
          });
*/
          // Prevent the default form submission
          return false;

        }
        const el = document.getElementById('shipping_type');
        const box = document.getElementById('box');
        el.addEventListener('change', function handleChange(event) {
            if (event.target.value === '2029') {
                box.style.display = 'block';
            } else {
                box.style.display = 'none';
            }
        });
    </script>
<?php
$pakke_post_js = ob_get_clean();

if (!defined('PAKKEPOST_JS'))
    define('PAKKEPOST_JS', $pakke_post_js);

function custom_metabox_content()
{
    global $wpdb;
    $post_id = isset($_GET['post']) ? $_GET['post'] : false;
    if (!$post_id) {
        return;
    }
    $order = wc_get_order($post_id);
    ?>
    <div style="width:100%;">
        <select data-pakketinput="1" name="shipping_type[<?php echo (int)$post_id; ?>]" id="shipping_type">
            <?php if (get_option('pakkepost_supplier') == 'Bring') { ?>
            <option value ="0"> - VELG - </option>
            <option value="153">Norge S - 35x22x10cm 1kg</option>
            <option value="2005">Norge M - 10kg</option>
            <option value="2006">Norge L - 20kg</option>
            <option value="2007">Norge XL - 35kg</option>
            <option value="2011">Bedrift S - 10kg</option>
            <option value="2013">Bedrift M - 35kg</option>

            <?php } else { ?>
            <option value ="0"> - VELG - </option>
            <option value="2038">Pakkeautomat - 50x30x20cm 5kg</option>
            <option value="2027">Medium - 5kg</option>
            <option value="2026">Stor - 10kg</option>
            <option value="2028">XL - 20kg</option>
            <option value="2029">XXL - 35 kg</option>
            <option value="2034">Bedrift Liten - 5kg</option>
            <option value="2036">Bedrift Medium - 15kg</option>
            <option value="2037">Bedrift Stor - 35kg</option>

            <?php } ?>
        </select>

        <select data-pakketinput="1" name="number_of_packages">
            <option value="1">1</option>
            <option value="2">2</option>
            <option value="3">3</option>
            <option value="4">4</option>
            <option value="5">5</option>
            <option value="6">6</option>
            <option value="7">7</option>
            <option value="8">8</option>
            <option value="9">9</option>
            <option value="10">10</option>
        </select>

        <a href="<?php echo(admin_url('admin-ajax.php?action=my_action_pakkepost')); ?>"
           id="book_shipment" class="button" target="_blank"
           onclick="return bookShipment(this, event, <?php echo (int)$post_id; ?>);">
            <?php _e('Book Shipment'); ?></a>
        <div style="line-height:1.5em;">

            <label for="home_delivery" style="float:left; margin-left:5px">
                <input data-pakketinput="1" type="checkbox" id="home_delivery"
                       name="home_delivery[<?php echo (int)$post_id; ?>]" value="hjemlevering"/>
                Hjemlevering / Pose på dør
            </label>

            <div style="line-height:1.5em;">

<!--            <div id="box" style="display: none">
                <label for="oversize-INDEX" style="float:left; margin-left:5px">
                    <input data-pakketinput="1" type="checkbox" id="oversize-INDEX"
                           name="oversize-INDEX[<?php /*echo (int)$post_id; */?>]" value="oversize"/>
                    Tillegg for overskridelse av lengde over 120cm og/eller volumvekt over 35kg (+ 230 kr)
                </label>
            </div>-->


        </div>

        <div style="width:100%;">
            <br /><br />

            <?php

            $order = wc_get_order($post_id);

            $query = $wpdb->prepare(
                'SELECT %1$s.post_content FROM %1$s WHERE %1$s.ID = '.(int)$post_id,
                $wpdb->posts
            );
            $pOrderIdResult = $wpdb->get_col($query);
            $jsonPOrderId = json_decode($pOrderIdResult[0]);
            $pakkepostOrderId = $jsonPOrderId->pakkepost_order_id;
            $pakkepost_user_id = get_option('pakkepost_user_id');
            $pakkepostSubscriptionKey = get_option('pakkepost_subscription_id');

            $api_mode = (get_option('api_mode') != '') ? get_option('api_mode') : 'Test';
            if ("Live" == $api_mode) {
                $trackingURL = "https://pakkepost.azure-api.net/tracking";
                $receiptURL = "https://pakkepost.azure-api.net/receipt";
            } else {
                $trackingURL = "https://pakkepost.azure-api.net/test/tracking";
                $receiptURL = "https://pakkepost.azure-api.net/test/receipt";
            }

            if ($pakkepostOrderId != null) {
            echo "<h4>Mine sendinger</h4>";
                $curl = curl_init();
                curl_setopt_array($curl, array(
                    CURLOPT_URL => $trackingURL.'?order_number='.$pakkepostOrderId,
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => '',
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 0,
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => 'GET',
                    CURLOPT_HTTPHEADER => array(
                        'Ocp-Apim-Subscription-Key: '. $pakkepostSubscriptionKey
                    ),
                ));

                $response = curl_exec($curl);
                $data = json_decode($response);
                curl_close($curl);
                if ($data != null ) {
                    if (isset($data->data[0])) {
                        if ($data->data[0]->consignmentNumber != null) {
                            $packageNumber = $data->data[0]->packageNumber;
                            $tracking = $data->data[0]->tracking;
                            $receiverName = $data->data[0]->receiverName;
                            $creationDate = $data->data[0]->creationdate;
                            $label = $data->data[0]->label;

                            $post_id = isset($_GET['post']) ? $_GET['post'] : false;
                            if (!$post_id) {
                                return;
                            }

                            $curl = curl_init();
                            curl_setopt_array($curl, array(
                                CURLOPT_URL => $receiptURL . '?userid=' . $pakkepost_user_id . '&order_number=' . $pakkepostOrderId,
                                CURLOPT_RETURNTRANSFER => true,
                                CURLOPT_ENCODING => '',
                                CURLOPT_MAXREDIRS => 10,
                                CURLOPT_TIMEOUT => 0,
                                CURLOPT_FOLLOWLOCATION => true,
                                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                                CURLOPT_CUSTOMREQUEST => 'GET',
                                CURLOPT_HTTPHEADER => array(
                                    'Ocp-Apim-Subscription-Key: ' . $pakkepostSubscriptionKey
                                ),
                            ));

                            $responseInvoice = curl_exec($curl);
                            $receiptResponse = json_decode($responseInvoice);
                            curl_close($curl);
                            if ($receiptResponse !== null) {
                                $receipt = $receiptResponse->data;
                            }

                            echo "<table class='trackingTable'>";
                            echo "<tr style='text-align: left; padding:10px;'>
                                 <th>ORDRE ID</th>
                                 <th>MOTTAKER</th>
                                 <th>PAKKENUMMER</th>
                                 <th>SPORING</th>
                                 <th>ETIKETT</th>
                                 <th>OPPRETTET</th>
                                 <th>KVITTERING</th>
                             </tr>";
                            echo "<tr>
                                 <td>" . $pakkepostOrderId . "</td>
                                 <td>" . $receiverName . "</td>
                                 <td>" . $packageNumber . "</td>
                                 <td><a href='$tracking'>" . $tracking . "</a></td>
                                 <td><a href='$label'>" . $label . "</a></td>
                                 <td>" . $creationDate . "</td>
                                 <td><a href='$receipt'>Last ned</a></td>
                             </tr>";
                            echo "</table>";
                        }
                    }
                }
            }

            ?>

        </div>


        <div class="clear"></div>
    </div>

    <?php

    echo PAKKEPOST_JS;

}

/**
 * Check if WooCommerce is active
 */
if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')))) {
    /**
     * WC_Pakkepost class
     */
    class Pakkepost_WooCommerce_Shipping
    {

        /**
         * Constructor
         */
        public function __construct()
        {

            add_filter('plugin_action_links_' . plugin_basename(__FILE__), array(
                $this,
                'wf_plugin_action_links'
            ));

            // Kodenor - Temporary disabling this filter as this is causing a 500 code error
/*            add_filter('woocommerce_my_account_my_orders_actions', array(
                            $this,
                            'view_order_action'
            ) , 10, 2);*/

            add_action('wp_ajax_my_action', array(
                $this,
                'my_action_pakkepost'
            ));
            add_action('wp_ajax_my_action_pakkepost', array(
                $this,
                'my_action_pakkepost'
            ));
            add_action('wp_ajax_nopriv_my_action', array(
                $this,
                'my_action_pakkepost'
            ));
            add_action('wp_ajax_nopriv_my_action_pakkepost', array(
                $this,
                'my_action_pakkepost'
            ));
            add_filter('woocommerce_get_sections_shipping', array(
                $this,
                'pakkepost_shipping_settings_tab'
            ));

            add_filter('woocommerce_get_settings_shipping', array(
                $this,
                'pakkepost_shipping_settings'
            ), 10, 2);

            add_action('manage_edit-shop_order_columns', array(
                $this,
                'sv_wc_cogs_add_order_profit_column_contents'
            ));

            add_action('manage_shop_order_posts_custom_column', array(
                $this,
                'sv_wc_cogs_add_order_profit_column_content'
            ));
            add_action('manage_posts_extra_tablenav', array(
                $this,
                'add_extra_button'
            ));

        }

        public function sv_wc_cogs_add_order_profit_column_contents($columns)
        {

            $new_columns = (is_array($columns)) ? $columns : array();
            unset($new_columns['wc_actions']);
            $new_columns['book_shipment'] = 'Shipment Type / Home Delivery';
            $new_columns['wc_actions'] = $columns['wc_actions'];
            return $new_columns;
        }

        public function sv_wc_cogs_add_order_profit_column_content($column)
        {
            global $post;

            if ('book_shipment' === $column ) {

                echo '<select data-pakketinput="1" name="shipping_type['.(int)$post->ID.']" class="shipping_type  no-link" style="max-width:100px;">';

                if (get_option('pakkepost_supplier') == 'Bring') {

                echo '<option value ="0"> - VELG - </option>
                    <option value="153">Norge S - 35x22x10cm 1kg</option>
                    <option value="2005">Norge M - 10kg</option>
                    <option value="2006">Norge L - 20kg</option>
                    <option value="2007">Norge XL - 35kg</option>
                    <option value="2011">Bedrift S - 10kg</option>
                    <option value="2013">Bedrift M - 35kg</option>';

                } else {
                    echo '<option value ="0"> - VELG - </option>
                        <option value="2038">Pakkeautomat - 50x30x20cm 5kg</option>
                        <option value="2027">Medium - 5kg</option>
                        <option value="2026">Stor - 10kg</option>
                        <option value="2028">XL - 20kg</option>
                        <option value="2029">XXL - 35 kg</option>
                        <option value="2034">Bedrift Liten - 5kg</option>
                        <option value="2036">Bedrift Medium - 15kg</option>
                        <option value="2037">Bedrift Stor - 35kg</option>';
                    }
                '</select> 
				<input data-pakketinput="1" type="checkbox" class="home_delivery no-link" name="home_delivery['.(int)$post->ID.']" value="hjemlevering" title="Hjemlevering / Pose på dør"  />
				';
            }
        }

        public function add_extra_button($where)
        {

            if ('top' === $where) {
                echo ' <a href="' . (admin_url('admin-ajax.php?action=my_action_pakkepost')) . '" id="book_shipment" class="button" onclick="return bookShipment(this, event, false);" >Book Shipment</a>';
                echo PAKKEPOST_JS;
            }
        }

        public function book_shipment_bulk_actions_orders($actions)
        {
            $actions['book_shipment'] = __('Book Shipment', 'woocommerce');
            return $actions;
        }

        public function pakkepost_shipping_settings($settings, $current_section)
        {

            $custom_settings = array();

            if ('pakkepost' == $current_section) {

                $custom_settings = array(

                    array(
                        'name' => __('Pakkepost'),
                        'type' => 'title',
                        'desc' => __('Pakkepost version streamlines your complete shipping process and saves time'),
                        'id' => 'pakkepost',
                    ),

                    array(
                        'name' => __('Pakkepost User Id'),
                        'type' => 'text',
                        'id' => 'pakkepost_user_id',
                        'custom_attributes' => array(
                            'required' => 'required'
                        ),
                    ),

                    array(
                        'name' => __('Pakkepost Subscription Id'),
                        'type' => 'text',
                        'id' => 'pakkepost_subscription_id',
                        'custom_attributes' => array(
                            'required' => 'required'
                        ),
                    ),
                    array(
                        'name' => __('Shop Name'),
                        'type' => 'text',
                        'id' => 'pakkepost_shop_name',
                        'custom_attributes' => array(
                            'required' => 'required'
                        ),
                    ),

                    array(
                        'name' => __('Pakkepost API Mode'),
                        'type' => 'select',
                        'desc' => __('Set as Test to switch to Pakkepost api test servers. Transaction will be treated as sample transactions by Pakkepost.'),
                        'desc_tip' => true,
                        'id' => 'api_mode',
                        'options' => array(

                            'Live' => __('Live'),
                            'Test' => __('Test'),
                        ),
                    ),
                    array(
                        'name' => __('Supplier'),
                        'type' => 'select',
                        'desc' => __('Select your supplier.'),
                        'desc_tip' => true,
                        'id' => 'pakkepost_supplier',
                        'options' => array(
                            'Bring' => __('Bring'),
                            'Postnord' => __('Postnord'),
                        ),

                    ),
                    array(
                        'name' => __('Sender Email'),
                        'type' => 'text',
                        'id' => 'sender_email',
                        'custom_attributes' => array(
                            'required' => 'required'
                        ),
                    ),
                    array(
                        'name' => __('Sender Phone Number'),
                        'type' => 'text',
                        'id' => 'sender_phone_number',
                        'custom_attributes' => array(
                            'required' => 'required'
                        ),
                    ),
                    array(
                        'type' => 'sectionend',
                        'id' => 'pakkepost_shipping'
                    ),
                );

                return $custom_settings;
            } else {
                return $settings;
            }

        }

        public function pakkepost_shipping_settings_tab($settings_tab)
        {
            $settings_tab['pakkepost'] = __('Pakkepost');
            return $settings_tab;
        }

        public function my_action_pakkepost()
        {
            global $wpdb;
            $order_ids = array();
            foreach ($_REQUEST["shipping_type"] as $orderId => $shipping_type) {
                $order_ids[] = $orderId;
            }
            $supplier = (get_option('pakkepost_supplier'));

            $api_mode = (get_option('api_mode') != '') ? get_option('api_mode') : 'Test';
            $pakkepost_user_id = (get_option('pakkepost_user_id') != '') ? get_option('pakkepost_user_id') : '863';

            $pakkepost_shop_name = (get_option('pakkepost_shop_name') != '') ? get_option('pakkepost_shop_name') : 'Shop 1';
            $pakkepost_subscription_id = (get_option('pakkepost_subscription_id') != '') ? get_option('pakkepost_subscription_id') : 'Test';
            $sender_email = (get_option('sender_email') != '') ? get_option('sender_email') : '';
            $sender_phone_number = (get_option('sender_phone_number') != '') ? get_option('sender_phone_number') : '';

            $store_address = get_option('woocommerce_store_address');
            $store_address_2 = get_option('woocommerce_store_address_2');
            $store_city = get_option('woocommerce_store_city');
            $store_postcode = get_option('woocommerce_store_postcode');

            $headers = array(
                "cache-control: no-cache",
                "content-type: application/json",
            );
            if ("Live" == $api_mode) {
                $headers[] = 'Ocp-Apim-Subscription-Key: ' . $pakkepost_subscription_id;
            }

            $data = array();

            $numberOfPackages = $_REQUEST["number_of_packages"];
            if ($numberOfPackages = "undefined") {
                $numberOfPackages = "1";
            }
            foreach ($order_ids as $key => $orderId) {
                $order = wc_get_order($orderId);
                $user = $order->get_user();
                $shipping_address = $order->get_address('shipping');
                if (empty($shipping_address['city']) && (empty($shipping_address['postcode']))) {
                    $shipping_address = $order->get_address('billing');
                }
                $shipping_type = (int)$_REQUEST["shipping_type"][$orderId];
                if (!empty($_REQUEST["home_delivery"][$orderId])) {
                    $additionalServices = 'hjemlevering';
                } else {
                    $additionalServices = '';
                }

                $data[] = array(
                    "userId" => (int)$pakkepost_user_id,
                    "senderName" => $pakkepost_shop_name,
                    "senderAddressLine" => $store_address,
                    "senderAddressLineNumber" => $store_address_2,
                    "senderPostalCode" => $store_postcode,
                    "senderCity" => $store_city,
                    "senderReference" => "WP" . $orderId ,
                    "senderEmail" => $sender_email,
                    "senderPhoneNumber" => (int)$sender_phone_number,
                    "recipientName" => $shipping_address["first_name"] . " " . $shipping_address["last_name"],
                    "recipientAddressLine" => $shipping_address["address_1"],
                    "recipientAddressLineNumber" => $shipping_address["address_2"],
                    "recipientPostalCode" => $shipping_address["postcode"],
                    "recipientCity" => $shipping_address["city"],
                    "recipientReference" => "",
                    "recipientPhoneNumber" => $order->get_billing_phone(),
                    "recipientEmail" => $order->get_billing_email(),
                    "productId" => (int)$shipping_type,
                    "additionalServices" => $additionalServices,
                    "numberOfPackages" => $numberOfPackages
                );
            }
            if (empty($data)) throw new Exception('No data found');
            if ("Live" == $api_mode) {
                $url = "https://pakkepost.azure-api.net/v2/booking";
            } else {
                $url = "https://pakkepost.azure-api.net/test/v2/booking";
            }
            $curl = curl_init($url);
            curl_setopt($curl, CURLOPT_URL, $url);
            curl_setopt($curl, CURLOPT_POST, true);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_VERBOSE, 1);
            //curl_setopt($curl, CURLOPT_STDERR, $fp);
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
            $response = curl_exec($curl);
            $err = curl_error($curl);
            $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
            curl_close($curl);

            $jsonResponse = json_decode($response);
            if ($err) {
                echo "cURL Error #:" . $err;
            } else {
                $wpdb->query(
                    $wpdb->prepare(
                            "
                             UPDATE `wp_posts` 
                             SET `post_content` = '{\"pakkepost_order_id\":\"$jsonResponse->orderId\"}' 
                             WHERE `wp_posts`.`ID` = '$orderId'; 
                            "
                    )
                );
                if ($jsonResponse->payment_link !== NULL) {
                    if (filter_var($jsonResponse->payment_link, FILTER_VALIDATE_URL) === false) {
                        echo $jsonResponse->payment_link;
                    } else {
                        header("Location: " . $jsonResponse->payment_link);
                        die();
                    }
                } else {
                    echo "<center> Det oppstod en feil: <br /> <br />" ."<b>". $jsonResponse->message[0] ."</b>";
                    echo "<br /> <br /> Vennligst prøv igjen senere eller kontakt support.";

                    wp_die();
                }
            }
            wp_die();
        }
        /**
         * Plugin page links
         */
        public function wf_plugin_action_links($links)
        {
            $plugin_links = array(
                '<a href="' . admin_url('admin.php?page=wc-settings&tab=shipping&section=pakkepost') . '">' . __('Settings', 'pakkepost_shipping') . '</a>',
            );
            return array_merge($plugin_links, $links);
        }
    }
    new Pakkepost_WooCommerce_Shipping();
}

